Index: bridges/bridge_native_rtp.c
===================================================================
--- bridges/bridge_native_rtp.c	(revision 400823)
+++ bridges/bridge_native_rtp.c	(working copy)
@@ -284,6 +284,24 @@
 		 */
 		find_bridged_channels(bridge, leaving, &c0, &c1);
 	} else {
+		enum ast_rtp_glue_result audio_glue_res;
+		enum ast_rtp_glue_result video_glue_res;
+
+		glue0 = ast_rtp_instance_get_glue(ast_channel_tech(leaving->chan)->type);
+		audio_glue_res = glue0->get_rtp_info(leaving->chan, &instance0);
+		video_glue_res = glue0->get_vrtp_info ? glue0->get_vrtp_info(leaving->chan, &vinstance0) : AST_RTP_GLUE_RESULT_FORBID;
+
+		/* Tear down P2P bridges */
+		ast_rtp_instance_set_bridged(instance0, NULL);
+		if (vinstance0) {
+			ast_rtp_instance_set_bridged(vinstance0, NULL);
+		}
+
+		if (audio_glue_res == AST_RTP_GLUE_RESULT_REMOTE
+			&& video_glue_res == AST_RTP_GLUE_RESULT_REMOTE) {
+			/* Direct RTP may have occurred, tear it down */
+			glue0->update_peer(leaving->chan, NULL, NULL, NULL, NULL, 0);
+		}
 		return;
 	}
 
